// designed for WINBOND W25Q128
// READ  the 3 Serial Flash Discoverable Parameter (SFDP) REGISTERS
// script can be adapted for other brand and models by changing 'RegSize' value in each section
{$ READ_JEDEC_ID}
begin
  ID:= CreateByteArray(3);
  if not SPIEnterProgMode(_SPI_SPEED_MAX) then LogPrint('Error setting SPI speed');
  LogPrint ('Start read JEDEC ID');
  
  // read ID to test installation 
  SPIWrite (0, 1, $9F);
  SPIRead(1, 3, ID);
  
  logprint('Read ID: ' + inttohex((GetArrayItem(ID, 0)),2)+ inttohex((GetArrayItem(ID, 1)),2)+ inttohex((GetArrayItem(ID, 2)),2));
  LogPrint ('End read JEDEC ID');
  SPIExitProgMode ();
end

{$ Read_SFDP_Register_1_W25Q128FV}
begin
  if not SPIEnterProgMode(_SPI_SPEED_MAX) then LogPrint('Error setting SPI speed');
  LogPrint ('Start read W25Q128FV SFDP Register #1');
  RegSize := 256;
  // read register 0
  SPIWrite (0, 5, $5A, $00, $10, $00, $00);
  SPIReadToEditor (1, RegSize);
   LogPrint ('End read W25Q128FV SFDP Register #1');
  SPIExitProgMode ();
end
 
 
{$ Read_SFDP_Register_2_W25Q128FV}
begin
  if not SPIEnterProgMode(_SPI_SPEED_MAX) then LogPrint('Error setting SPI speed');
  LogPrint ('Start read W25Q128FV SFDP Register #2');
  RegSize := 256;
  // read register 0
  SPIWrite (0, 5, $5A, $00, $20, $00, $00);
  SPIReadToEditor (1, RegSize);
   LogPrint ('End read W25Q128FV SFDP Register #2');
  SPIExitProgMode ();
end

{$ Read_SFDP_Register_3_W25Q128FV}
begin
  if not SPIEnterProgMode(_SPI_SPEED_MAX) then LogPrint('Error setting SPI speed');
  LogPrint ('Start read W25Q128FV SFDP Register #3');
  RegSize := 256;
  // read register 0
  SPIWrite (0, 5, $5A, $00, $30, $00, $00);
  SPIReadToEditor (1, RegSize);
   LogPrint ('End read W25Q128FV SFDP Register #3');
  SPIExitProgMode ();
end
